    /*
     * Some or all of this work - Copyright (c) 2006 - 2019, Intel Corp.
     * All rights reserved.
     *
     * Redistribution and use in source and binary forms, with or without modification,
     * are permitted provided that the following conditions are met:
     *
     * Redistributions of source code must retain the above copyright notice,
     * this list of conditions and the following disclaimer.
     * Redistributions in binary form must reproduce the above copyright notice,
     * this list of conditions and the following disclaimer in the documentation
     * and/or other materials provided with the distribution.
     * Neither the name of Intel Corporation nor the names of its contributors
     * may be used to endorse or promote products derived from this software
     * without specific prior written permission.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
     * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
     * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
     * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
     * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
     * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     */
    /*
     * Data type conversion and manipulation
     */
    /* String To Unicode Conversion Macro */
    Name (P358, Package (0x04)
    {
        Buffer (0x02)
        {
             0x00, 0x00                                       // ..
        },

        Unicode (" "),
        Buffer (0x0100)
        {
            /* 0000 */  0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x04, 0x00,  // ........
            /* 0008 */  0x05, 0x00, 0x06, 0x00, 0x07, 0x00, 0x08, 0x00,  // ........
            /* 0010 */  0x09, 0x00, 0x0A, 0x00, 0x0B, 0x00, 0x0C, 0x00,  // ........
            /* 0018 */  0x0D, 0x00, 0x0E, 0x00, 0x0F, 0x00, 0x10, 0x00,  // ........
            /* 0020 */  0x11, 0x00, 0x12, 0x00, 0x13, 0x00, 0x14, 0x00,  // ........
            /* 0028 */  0x15, 0x00, 0x16, 0x00, 0x17, 0x00, 0x18, 0x00,  // ........
            /* 0030 */  0x19, 0x00, 0x1A, 0x00, 0x1B, 0x00, 0x1C, 0x00,  // ........
            /* 0038 */  0x1D, 0x00, 0x1E, 0x00, 0x1F, 0x00, 0x20, 0x00,  // ...... .
            /* 0040 */  0x21, 0x00, 0x22, 0x00, 0x23, 0x00, 0x24, 0x00,  // !.".#.$.
            /* 0048 */  0x25, 0x00, 0x26, 0x00, 0x27, 0x00, 0x28, 0x00,  // %.&.'.(.
            /* 0050 */  0x29, 0x00, 0x2A, 0x00, 0x2B, 0x00, 0x2C, 0x00,  // ).*.+.,.
            /* 0058 */  0x2D, 0x00, 0x2E, 0x00, 0x2F, 0x00, 0x30, 0x00,  // -.../.0.
            /* 0060 */  0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00,  // 1.2.3.4.
            /* 0068 */  0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00,  // 5.6.7.8.
            /* 0070 */  0x39, 0x00, 0x3A, 0x00, 0x3B, 0x00, 0x3C, 0x00,  // 9.:.;.<.
            /* 0078 */  0x3D, 0x00, 0x3E, 0x00, 0x3F, 0x00, 0x40, 0x00,  // =.>.?.@.
            /* 0080 */  0x41, 0x00, 0x42, 0x00, 0x43, 0x00, 0x44, 0x00,  // A.B.C.D.
            /* 0088 */  0x45, 0x00, 0x46, 0x00, 0x47, 0x00, 0x48, 0x00,  // E.F.G.H.
            /* 0090 */  0x49, 0x00, 0x4A, 0x00, 0x4B, 0x00, 0x4C, 0x00,  // I.J.K.L.
            /* 0098 */  0x4D, 0x00, 0x4E, 0x00, 0x4F, 0x00, 0x50, 0x00,  // M.N.O.P.
            /* 00A0 */  0x51, 0x00, 0x52, 0x00, 0x53, 0x00, 0x54, 0x00,  // Q.R.S.T.
            /* 00A8 */  0x55, 0x00, 0x56, 0x00, 0x57, 0x00, 0x58, 0x00,  // U.V.W.X.
            /* 00B0 */  0x59, 0x00, 0x5A, 0x00, 0x5B, 0x00, 0x5C, 0x00,  // Y.Z.[.\.
            /* 00B8 */  0x5D, 0x00, 0x5E, 0x00, 0x5F, 0x00, 0x60, 0x00,  // ].^._.`.
            /* 00C0 */  0x61, 0x00, 0x62, 0x00, 0x63, 0x00, 0x64, 0x00,  // a.b.c.d.
            /* 00C8 */  0x65, 0x00, 0x66, 0x00, 0x67, 0x00, 0x68, 0x00,  // e.f.g.h.
            /* 00D0 */  0x69, 0x00, 0x6A, 0x00, 0x6B, 0x00, 0x6C, 0x00,  // i.j.k.l.
            /* 00D8 */  0x6D, 0x00, 0x6E, 0x00, 0x6F, 0x00, 0x70, 0x00,  // m.n.o.p.
            /* 00E0 */  0x71, 0x00, 0x72, 0x00, 0x73, 0x00, 0x74, 0x00,  // q.r.s.t.
            /* 00E8 */  0x75, 0x00, 0x76, 0x00, 0x77, 0x00, 0x78, 0x00,  // u.v.w.x.
            /* 00F0 */  0x79, 0x00, 0x7A, 0x00, 0x7B, 0x00, 0x7C, 0x00,  // y.z.{.|.
            /* 00F8 */  0x7D, 0x00, 0x7E, 0x00, 0x7F, 0x00, 0x00, 0x00   // }.~.....
        },

        Unicode ("!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~ !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~ !\"#$%&'()*")
    })
    Name (P359, Package (0x04)
    {
        Buffer (0x02)
        {
             0x00, 0x00                                       // ..
        },

        Unicode (" "),
        Buffer (0x0100)
        {
            /* 0000 */  0x01, 0x00, 0x02, 0x00, 0x03, 0x00, 0x04, 0x00,  // ........
            /* 0008 */  0x05, 0x00, 0x06, 0x00, 0x07, 0x00, 0x08, 0x00,  // ........
            /* 0010 */  0x09, 0x00, 0x0A, 0x00, 0x0B, 0x00, 0x0C, 0x00,  // ........
            /* 0018 */  0x0D, 0x00, 0x0E, 0x00, 0x0F, 0x00, 0x10, 0x00,  // ........
            /* 0020 */  0x11, 0x00, 0x12, 0x00, 0x13, 0x00, 0x14, 0x00,  // ........
            /* 0028 */  0x15, 0x00, 0x16, 0x00, 0x17, 0x00, 0x18, 0x00,  // ........
            /* 0030 */  0x19, 0x00, 0x1A, 0x00, 0x1B, 0x00, 0x1C, 0x00,  // ........
            /* 0038 */  0x1D, 0x00, 0x1E, 0x00, 0x1F, 0x00, 0x20, 0x00,  // ...... .
            /* 0040 */  0x21, 0x00, 0x22, 0x00, 0x23, 0x00, 0x24, 0x00,  // !.".#.$.
            /* 0048 */  0x25, 0x00, 0x26, 0x00, 0x27, 0x00, 0x28, 0x00,  // %.&.'.(.
            /* 0050 */  0x29, 0x00, 0x2A, 0x00, 0x2B, 0x00, 0x2C, 0x00,  // ).*.+.,.
            /* 0058 */  0x2D, 0x00, 0x2E, 0x00, 0x2F, 0x00, 0x30, 0x00,  // -.../.0.
            /* 0060 */  0x31, 0x00, 0x32, 0x00, 0x33, 0x00, 0x34, 0x00,  // 1.2.3.4.
            /* 0068 */  0x35, 0x00, 0x36, 0x00, 0x37, 0x00, 0x38, 0x00,  // 5.6.7.8.
            /* 0070 */  0x39, 0x00, 0x3A, 0x00, 0x3B, 0x00, 0x3C, 0x00,  // 9.:.;.<.
            /* 0078 */  0x3D, 0x00, 0x3E, 0x00, 0x3F, 0x00, 0x40, 0x00,  // =.>.?.@.
            /* 0080 */  0x41, 0x00, 0x42, 0x00, 0x43, 0x00, 0x44, 0x00,  // A.B.C.D.
            /* 0088 */  0x45, 0x00, 0x46, 0x00, 0x47, 0x00, 0x48, 0x00,  // E.F.G.H.
            /* 0090 */  0x49, 0x00, 0x4A, 0x00, 0x4B, 0x00, 0x4C, 0x00,  // I.J.K.L.
            /* 0098 */  0x4D, 0x00, 0x4E, 0x00, 0x4F, 0x00, 0x50, 0x00,  // M.N.O.P.
            /* 00A0 */  0x51, 0x00, 0x52, 0x00, 0x53, 0x00, 0x54, 0x00,  // Q.R.S.T.
            /* 00A8 */  0x55, 0x00, 0x56, 0x00, 0x57, 0x00, 0x58, 0x00,  // U.V.W.X.
            /* 00B0 */  0x59, 0x00, 0x5A, 0x00, 0x5B, 0x00, 0x5C, 0x00,  // Y.Z.[.\.
            /* 00B8 */  0x5D, 0x00, 0x5E, 0x00, 0x5F, 0x00, 0x60, 0x00,  // ].^._.`.
            /* 00C0 */  0x61, 0x00, 0x62, 0x00, 0x63, 0x00, 0x64, 0x00,  // a.b.c.d.
            /* 00C8 */  0x65, 0x00, 0x66, 0x00, 0x67, 0x00, 0x68, 0x00,  // e.f.g.h.
            /* 00D0 */  0x69, 0x00, 0x6A, 0x00, 0x6B, 0x00, 0x6C, 0x00,  // i.j.k.l.
            /* 00D8 */  0x6D, 0x00, 0x6E, 0x00, 0x6F, 0x00, 0x70, 0x00,  // m.n.o.p.
            /* 00E0 */  0x71, 0x00, 0x72, 0x00, 0x73, 0x00, 0x74, 0x00,  // q.r.s.t.
            /* 00E8 */  0x75, 0x00, 0x76, 0x00, 0x77, 0x00, 0x78, 0x00,  // u.v.w.x.
            /* 00F0 */  0x79, 0x00, 0x7A, 0x00, 0x7B, 0x00, 0x7C, 0x00,  // y.z.{.|.
            /* 00F8 */  0x7D, 0x00, 0x7E, 0x00, 0x7F, 0x00, 0x00, 0x00   // }.~.....
        },

        Unicode ("!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~ !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~ !\"#$%&'()*")
    })
    /* Run-method */

    Method (UNI0, 0, Serialized)
    {
        Debug = "TEST: UNI0, String To Unicode Conversion Macro"
        M302 (__METHOD__, 0x04, "p358", P358, P359, 0x08)
    }
